/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
*/

/*	Copyright (c) 1984, 1986, 1987, 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: wctomb.c 1.3 90/05/03 $@(#)libc-port:locale/wctomb.c	1.0"

#include <ctype.h>
#include <stdlib.h>
#define multibyte       (_ctype[520]>1)
#define eucw1   _ctype[514]
#define eucw2   _ctype[515]
#define eucw3   _ctype[516]
#define EUCMASK 0x30000000
#define P00     0x00000000      /* Code Set 0 */
#define P11     0x30000000      /* Code Set 1 */
#define P01     0x10000000      /* Code Set 2 */
#define P10     0x20000000      /* Code Set 3 */
#define SS2     0x8e
#define SS3     0x8f
/*
 *	The followings are for 2 bytes of multi-byte code definition.
 */
#define H_EUCMASK 0x8080	/* mask bit for 16 bits */
#define H_P00     0x0000	/* Code Set 0 for 2 bytes code */
#define H_P11     0x8080	/* Code Set 1 for 2 bytes code */
#define H_P01     0x0080	/* Code Set 2 for 2 bytes code */
#define H_P10     0x8000	/* Code Set 3 for 2 bytes code */

int wctomb(s, wchar)
char *s;
wchar_t wchar;
{
        char *olds = s;
        register int size, index;
        unsigned char d;
	short	pcw;	/* process code width */
        if(!s)
                return(0);

				/* MNLS defines space as cntrl */
        if ((!multibyte) || (wchar <= 0177) || (wchar <= 0377)
			 && ((iscntrl(wchar)) || (wchar == 040))) {
                *s++ = (char)wchar;
                return(1);
        }
	if ( eucw1 > sizeof(unsigned short) ||
	     eucw2 > sizeof(unsigned short) ||
	     eucw3 > sizeof(unsigned short))
		pcw = sizeof(unsigned long);	/* 32 bits process code */
	else
		pcw = sizeof(unsigned short);	/* 16 bits process code */
	if (pcw > sizeof(unsigned short)) {
        switch(wchar & EUCMASK) {
                
                case P11:
                        size = eucw1;
                        break;
                
                case P01:
                        *s++ = (char)SS2;
                        size = eucw2;
                        break;
                
                case P10:
                        *s++ = (char)SS3;
                        size = eucw3;
                        break;
                
                default:
                        return(-1);
        }
	} else {
        switch(wchar & H_EUCMASK) {
                
                case H_P11:
                        size = eucw1;
                        break;
                
                case H_P01:
                        *s++ = (char)SS2;
                        size = eucw2;
                        break;
                
                case H_P10:
                        *s++ = (char)SS3;
                        size = eucw3;
                        break;
                
                default:
                        return(-1);
        }
	}
        if((index = size) <= 0)
                return -1;      

        while(index--) {
                d = wchar & ~0200;
		if (pcw > sizeof(unsigned short))
                	wchar >>= 7;
		else
	                wchar >>= 8;

                if ((iscntrl(d)) || (d == 040))
                        return(-1);

                s[index] = d | 0200;
        }
        return(s + size - olds);
}
